diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/utils.py
new file mode 100644
index 0000000..ce8c3d0
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/utils.py
@@ -0,0 +1,77 @@
+# ##########################################################################
+#
+# #pgAdmin 4 - PostgreSQL Tools
+#
+# #Copyright (C) 2013 - 2016, The pgAdmin Development Team
+# #This software is released under the PostgreSQL Licence
+#
+# ##########################################################################
+from __future__ import print_function
+import traceback
+import sys
+
+from regression import test_utils as utils
+
+
+def create_domain(server, db_name, schema_name, schema_id, domain_name):
+    """
+    This function is used to add the domain to existing schema
+    :param server: server details
+    :type server: dict
+    :param db_name: database name
+    :type db_name: str
+    :param schema_name: schema name
+    :type schema_name: str
+    :param schema_id: schema id
+    :type schema_id: int
+    :param domain_name: domain name
+    :type domain_name: str
+    :return: None
+    """
+    try:
+        connection = utils.get_db_connection(db_name,
+                                             server['username'],
+                                             server['db_password'],
+                                             server['host'],
+                                             server['port'])
+        pg_cursor = connection.cursor()
+        query = 'CREATE DOMAIN '+schema_name+'.'+domain_name+' AS' \
+                ' character(10) COLLATE pg_catalog."POSIX" DEFAULT 1'
+        pg_cursor.execute(query)
+        connection.commit()
+        # Get 'oid' from newly created domain
+        pg_cursor.execute("SELECT d.oid, d.typname FROM pg_type d WHERE"
+                          " d.typname='%s' AND d.typnamespace='%s'" %
+                          (domain_name, schema_id))
+        domains = pg_cursor.fetchone()
+        connection.close()
+        return domains
+    except Exception:
+        traceback.print_exc(file=sys.stderr)
+
+
+def verify_domain(server, db_name, schema_id, domain_name):
+    """
+    This function get the oid & name of the domain
+    :param server: server details
+    :type server: dict
+    :param db_name: db name
+    :type db_name: str
+    :param schema_id: schema id
+    :type schema_id: int
+    :param domain_name: domain name
+    :type domain_name: str
+    :return:
+    """
+    connection = utils.get_db_connection(db_name,
+                                         server['username'],
+                                         server['db_password'],
+                                         server['host'],
+                                         server['port'])
+    pg_cursor = connection.cursor()
+    pg_cursor.execute("SELECT d.oid, d.typname FROM pg_type d WHERE"
+                      " d.typname='%s' AND d.typnamespace='%s'" %
+                      (domain_name, schema_id))
+    domains = pg_cursor.fetchone()
+    connection.close()
+    return domains
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_add.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_add.py
index 82c68cb..a623b2f 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_add.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_add.py
@@ -6,69 +6,94 @@
 # This software is released under the PostgreSQL Licence
 #
 # ##################################################################
+import uuid
+import json
 
 from regression import test_utils as utils
+from regression import parent_node_dict
 from pgadmin.utils.route import BaseTestGenerator
-from pgadmin.browser.server_groups.servers.tests import utils as server_utils
 from pgadmin.browser.server_groups.servers.databases.tests import utils as \
     database_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
     utils as schema_utils
-from . import utils as trigger_funcs_utils
 
 
 class TriggerFuncAddTestCase(BaseTestGenerator):
     """ This class will add new trigger function under schema node. """
-
     scenarios = [
         # Fetching default URL for trigger function node.
         ('Fetch Trigger Function Node URL', dict(
             url='/browser/trigger_function/obj/'))
     ]
 
-    @classmethod
-    def setUpClass(cls):
-        """
-        This function perform the three tasks
-         1. Add the test server
-         2. Connect to server
-         3. Add the databases
-         4. Add the schemas
-
-        :return: None
-        """
-
-        # Firstly, add the server
-        server_utils.add_server(cls.tester)
-        # Connect to server
-        cls.server_connect_response, cls.server_group, cls.server_ids = \
-            server_utils.connect_server(cls.tester)
-        if len(cls.server_connect_response) == 0:
-            raise Exception("No Server(s) connected to add the database!!!")
-        # Add database
-        database_utils.add_database(cls.tester, cls.server_connect_response,
-                                    cls.server_ids)
-        # Add schemas
-        schema_utils.add_schemas(cls.tester)
-
     def runTest(self):
         """ This function will add trigger function under schema node. """
+        db_name = parent_node_dict["database"][-1]["db_name"]
+        schema_info = parent_node_dict["schema"][-1]
+        server_id = schema_info["server_id"]
+        db_id = schema_info["db_id"]
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 server_id, db_id)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add a function.")
+        schema_id = schema_info["schema_id"]
+        schema_name = schema_info["schema_name"]
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      db_name,
+                                                      schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to add a function.")
+        db_user = self.server["username"]
+        data = {
+            "acl": [
+                {
+                    "grantee": db_user,
+                    "grantor": db_user,
+                    "privileges":
+                        [
+                            {
+                                "privilege_type": "X",
+                                "privilege": True,
+                                "with_grant": True
+                            }
+                        ]
+                }
+            ],
+            "arguments": [],
+            "funcowner": db_user,
+            "lanname": "plpgsql",
+            "name": "test_abort_any_command",
+            "options": [],
+            "proleakproof": True,
+            "pronamespace": 2200,
+            "prorettypename": "event_trigger/trigger",
+            "prosecdef": True,
+            "prosrc": "BEGIN RAISE EXCEPTION 'command % is disabled',"
+                      " tg_tag; END;",
+            "provolatile": "s",
+            "seclabels": [],
+            "variables": [
+                {
+                    "name": "enable_sort",
+                    "value": True
+                }
+            ]
+        }
+        # Get the type from data. We are adding two types
+        # i.e. event_trigger and trigger.
+        trigger_func_types = data['prorettypename'].split('/')
+        for func_type in trigger_func_types:
+            data['prorettypename'] = func_type
+            data["name"] = "test_event_add_%s" % str(uuid.uuid4())[1:6]
+            if schema_id:
+                data['pronamespace'] = schema_id
+            else:
+                schema_id = data['pronamespace']
+            response = self.tester.post(
+                self.url + str(utils.SERVER_GROUP) + '/' +
+                str(server_id) + '/' + str(db_id) + '/' + str(schema_id)
+                + '/', data=json.dumps(data), content_type='html/json')
 
-        trigger_funcs_utils.add_trigger_function(
-            self.tester, self.server_connect_response, self.server_ids)
-
-    @classmethod
-    def tearDownClass(cls):
-        """
-        This function deletes the added trigger function, schemas, database,
-        server and the 'parent_id.pkl' file which is created in setup()
-        function.
-
-        :return: None
-        """
-
-        trigger_funcs_utils.delete_trigger_function(cls.tester)
-        schema_utils.delete_schema(cls.tester)
-        database_utils.delete_database(cls.tester)
-        server_utils.delete_server(cls.tester)
-        utils.delete_parent_id_file()
+            self.assertEquals(response.status_code, 200)
+        # Disconnect the database
+        database_utils.disconnect_database(self, server_id, db_id)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_delete.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_delete.py
index 3de5b4e..5f28ed4 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_delete.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_delete.py
@@ -6,8 +6,10 @@
 # This software is released under the PostgreSQL Licence
 #
 # ##################################################################
+import uuid
 
 from regression import test_utils as utils
+from regression import parent_node_dict
 from pgadmin.utils.route import BaseTestGenerator
 from pgadmin.browser.server_groups.servers.tests import utils as server_utils
 from pgadmin.browser.server_groups.servers.databases.tests import utils as \
@@ -19,59 +21,44 @@ from . import utils as trigger_funcs_utils
 
 class TriggerFuncDeleteTestCase(BaseTestGenerator):
     """ This class will delete the trigger function under schema node. """
-
     scenarios = [
         # Fetching default URL for trigger function node.
         ('Fetch Trigger Function Node URL',
          dict(url='/browser/trigger_function/obj/'))
     ]
 
-    @classmethod
-    def setUpClass(cls):
-        """
-        This function perform the three tasks
-         1. Add the test server
-         2. Connect to server
-         3. Add the databases
-         4. Add the schemas
-         5. Add the trigger functions
-
-        :return: None
-        """
-
-        # Firstly, add the server
-        server_utils.add_server(cls.tester)
-        # Connect to server
-        cls.server_connect_response, cls.server_group, cls.server_ids = \
-            server_utils.connect_server(cls.tester)
-        if len(cls.server_connect_response) == 0:
-            raise Exception("No Server(s) connected to add the database!!!")
-        # Add database
-        database_utils.add_database(cls.tester, cls.server_connect_response,
-                                    cls.server_ids)
-        # Add schemas
-        schema_utils.add_schemas(cls.tester)
-
-        # Add trigger functions
-        trigger_funcs_utils.add_trigger_function(
-            cls.tester, cls.server_connect_response, cls.server_ids)
+    def setUp(self):
+        self.db_name = parent_node_dict["database"][-1]["db_name"]
+        self.schema_name = parent_node_dict["schema"][-1]["schema_name"]
+        self.schema_id = parent_node_dict["schema"][-1]["schema_id"]
+        func_name = "test_event_delete_%s" % str(uuid.uuid4())[1:6]
+        db_user = self.server["username"]
+        self.function_info = trigger_funcs_utils.create_trigger_function(
+            self.server, self.db_name, self.schema_name, func_name)
 
     def runTest(self):
         """ This function will delete trigger function under database node. """
+        schema_info = parent_node_dict["schema"][-1]
+        server_id = schema_info["server_id"]
+        db_id = schema_info["db_id"]
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 server_id, db_id)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add collation.")
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to add the collation.")
+        trigger_func_id = self.function_info[0]
+        response = self.tester.delete(
+            self.url + str(utils.SERVER_GROUP) + '/'
+            + str(server_id) + '/' + str(db_id) + '/' +
+            str(self.schema_id) + '/' + str(trigger_func_id),
+            content_type='html/json')
+        self.assertEquals(response.status_code, 200)
+        # Disconnect the database
+        database_utils.disconnect_database(self, server_id, db_id)
 
-        trigger_funcs_utils.delete_trigger_function(self.tester)
-
-    @classmethod
-    def tearDownClass(cls):
-        """
-        This function deletes the added trigger function, schemas, database,
-        server and the 'parent_id.pkl' file which is created in setup()
-        function.
-
-        :return: None
-        """
-
-        schema_utils.delete_schema(cls.tester)
-        database_utils.delete_database(cls.tester)
-        server_utils.delete_server(cls.tester)
-        utils.delete_parent_id_file()
+    def tearDown(self):
+        pass
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_get.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_get.py
index 0ba2bca..b31729a 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_get.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_get.py
@@ -6,10 +6,11 @@
 # This software is released under the PostgreSQL Licence
 #
 # ##################################################################
+import uuid
 
 from regression import test_utils as utils
+from regression import parent_node_dict
 from pgadmin.utils.route import BaseTestGenerator
-from pgadmin.browser.server_groups.servers.tests import utils as server_utils
 from pgadmin.browser.server_groups.servers.databases.tests import utils as \
     database_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
@@ -19,80 +20,44 @@ from . import utils as trigger_funcs_utils
 
 class TriggerFuncGetTestCase(BaseTestGenerator):
     """This class will fetch added trigger function under schema node."""
-
     scenarios = [
         # Fetching default URL for trigger function node.
         ('Fetch Trigger Function Node URL',
          dict(url='/browser/trigger_function/obj/'))
     ]
 
-    @classmethod
-    def setUpClass(cls):
-        """
-        This function perform the three tasks
-         1. Add the test server
-         2. Connect to server
-         3. Add the databases
-         4. Add the schemas
-         5. Add the trigger functions
-
-        :return: None
-        """
-
-        # Firstly, add the server
-        server_utils.add_server(cls.tester)
-        # Connect to server
-        cls.server_connect_response, cls.server_group, cls.server_ids = \
-            server_utils.connect_server(cls.tester)
-        if len(cls.server_connect_response) == 0:
-            raise Exception("No Server(s) connected to add the database!!!")
-        # Add database
-        database_utils.add_database(cls.tester, cls.server_connect_response,
-                                    cls.server_ids)
-        # Add schemas
-        schema_utils.add_schemas(cls.tester)
-        # Add trigger functions
-        trigger_funcs_utils.add_trigger_function(
-            cls.tester, cls.server_connect_response, cls.server_ids)
+    def setUp(self):
+        self.db_name = parent_node_dict["database"][-1]["db_name"]
+        self.schema_name = parent_node_dict["schema"][-1]["schema_name"]
+        self.schema_id = parent_node_dict["schema"][-1]["schema_id"]
+        func_name = "test_event_get_%s" % str(uuid.uuid4())[1:6]
+        db_user = self.server["username"]
+        self.function_info = trigger_funcs_utils.create_trigger_function(
+            self.server, self.db_name, self.schema_name, func_name)
 
     def runTest(self):
         """ This function will delete trigger function under database node. """
-
-        all_id = utils.get_ids()
-        server_ids = all_id["sid"]
-        db_ids_dict = all_id["did"][0]
-        schema_ids_dict = all_id["scid"][0]
-        trigger_ids_dict = all_id["tfnid"][0]
-        for server_id in server_ids:
-            db_id = db_ids_dict[int(server_id)]
-            db_con = database_utils.verify_database(
-                self.tester, utils.SERVER_GROUP, server_id, db_id)
-            if db_con['data']["connected"]:
-                schema_id = schema_ids_dict[int(server_id)][0]
-                schema_response = schema_utils.verify_schemas(
-                    self.tester, server_id, db_id, schema_id)
-                if schema_response.status_code == 200:
-                    trigger_func_list = trigger_ids_dict[int(server_id)]
-                    for trigger_func in trigger_func_list:
-                        trigger_func_id = trigger_func[0]
-                        trigger_response = \
-                            trigger_funcs_utils.verify_trigger_function(
-                                self.tester, server_id, db_id, schema_id,
-                                trigger_func_id)
-                        self.assertTrue(trigger_response.status_code, 200)
-
-    @classmethod
-    def tearDownClass(cls):
-        """
-        This function deletes the added trigger function, schemas, database,
-        server and the 'parent_id.pkl' file which is created in setup()
-        function.
-
-        :return: None
-        """
-
-        trigger_funcs_utils.delete_trigger_function(cls.tester)
-        schema_utils.delete_schema(cls.tester)
-        database_utils.delete_database(cls.tester)
-        server_utils.delete_server(cls.tester)
-        utils.delete_parent_id_file()
+        schema_info = parent_node_dict["schema"][-1]
+        server_id = schema_info["server_id"]
+        db_id = schema_info["db_id"]
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 server_id, db_id)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add collation.")
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to add the collation.")
+        trigger_func_id = self.function_info[0]
+        response = self.tester.get(
+            self.url + str(utils.SERVER_GROUP) + '/'
+            + str(server_id) + '/' + str(db_id) + '/' +
+            str(self.schema_id) + '/' + str(trigger_func_id),
+            content_type='html/json')
+        self.assertEquals(response.status_code, 200)
+        # Disconnect the database
+        database_utils.disconnect_database(self, server_id, db_id)
+
+    def tearDown(self):
+        pass
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_put.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_put.py
index 5025d40..1250a24 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_put.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/tests/test_trigger_func_put.py
@@ -6,13 +6,12 @@
 # This software is released under the PostgreSQL Licence
 #
 # ##################################################################
-
+import uuid
 import json
 
 from regression import test_utils as utils
+from regression import parent_node_dict
 from pgadmin.utils.route import BaseTestGenerator
-from regression.test_setup import advanced_config_data
-from pgadmin.browser.server_groups.servers.tests import utils as server_utils
 from pgadmin.browser.server_groups.servers.databases.tests import utils as \
     database_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
@@ -22,99 +21,59 @@ from . import utils as trigger_funcs_utils
 
 class TriggerFuncPutTestCase(BaseTestGenerator):
     """ This class will update new trigger function under schema node. """
-
     scenarios = [
         # Fetching default URL for trigger function node.
         ('Fetch Trigger Function Node URL',
          dict(url='/browser/trigger_function/obj/'))
     ]
 
-    @classmethod
-    def setUpClass(cls):
-        """
-        This function perform the three tasks
-         1. Add the test server
-         2. Connect to server
-         3. Add the databases
-         4. Add the schemas
-         5. Add the trigger functions
-
-        :return: None
-        """
-
-        # Firstly, add the server
-        server_utils.add_server(cls.tester)
-        # Connect to server
-        cls.server_connect_response, cls.server_group, cls.server_ids = \
-            server_utils.connect_server(cls.tester)
-        if len(cls.server_connect_response) == 0:
-            raise Exception("No Server(s) connected to add the database!!!")
-        # Add database
-        database_utils.add_database(cls.tester, cls.server_connect_response,
-                                    cls.server_ids)
-        # Add schemas
-        schema_utils.add_schemas(cls.tester)
-        # Add trigger functions
-        trigger_funcs_utils.add_trigger_function(
-            cls.tester, cls.server_connect_response, cls.server_ids)
+    def setUp(self):
+        self.db_name = parent_node_dict["database"][-1]["db_name"]
+        self.schema_name = parent_node_dict["schema"][-1]["schema_name"]
+        self.schema_id = parent_node_dict["schema"][-1]["schema_id"]
+        func_name = "test_event_put_%s" % str(uuid.uuid4())[1:6]
+        db_user = self.server["username"]
+        self.function_info = trigger_funcs_utils.create_trigger_function(
+            self.server, self.db_name, self.schema_name, func_name)
 
     def runTest(self):
         """ This function will update trigger function under database node. """
+        schema_info = parent_node_dict["schema"][-1]
+        server_id = schema_info["server_id"]
+        db_id = schema_info["db_id"]
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 server_id, db_id)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add collation.")
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to add the collation.")
+        func_name = self.function_info[1]
+        func_response = trigger_funcs_utils.verify_trigger_function(
+            self.server,
+            self.db_name,
+            func_name)
+        if not func_response:
+            raise Exception("Could not find the trigger function to update"
+                            " it's details.")
 
-        all_id = utils.get_ids()
-        server_ids = all_id["sid"]
-        db_ids_dict = all_id["did"][0]
-        schema_ids_dict = all_id["scid"][0]
-        trigger_ids_dict = all_id["tfnid"][0]
-        for server_id in server_ids:
-            db_id = db_ids_dict[int(server_id)]
-            db_con = database_utils.verify_database(self.tester,
-                                                    utils.SERVER_GROUP,
-                                                    server_id, db_id)
-            if db_con['data']["connected"]:
-                schema_id = schema_ids_dict[int(server_id)]
-                schema_response = schema_utils.verify_schemas(self.tester,
-                                                              server_id,
-                                                              db_id,
-                                                              schema_id)
-                if schema_response.status_code == 200:
-                    trigger_func_list = trigger_ids_dict[int(server_id)]
-                    for trigger_func in trigger_func_list:
-                        trigger_func_id = trigger_func[0]
-                        trigger_response = \
-                            trigger_funcs_utils.verify_trigger_function(
-                                self.tester, server_id, db_id, schema_id,
-                                trigger_func_id)
-                        if trigger_response.status_code == 200:
-                            data = {
-                                "description": advanced_config_data[
-                                    'trigger_func_update_data']['comment'],
-                                "id": trigger_func_id
-                            }
-
-                            put_response = self.tester.put(
-                                self.url + str(utils.SERVER_GROUP) + '/' +
-                                str(server_id) + '/' +
-                                str(db_id) + '/' +
-                                str(schema_id) + '/' +
-                                str(trigger_func_id),
-                                data=json.dumps(data),
-                                follow_redirects=True)
-
-                            self.assertEquals(put_response.status_code, 200)
-
-    @classmethod
-    def tearDownClass(cls):
-        """
-        This function deletes the added trigger function, schemas, database,
-        server and the 'parent_id.pkl' file which is created in setup()
-        function.
+        trigger_func_id = self.function_info[0]
+        data = {
+            "description": "This is trigger function update comment",
+            "id": trigger_func_id
+        }
 
-        :return: None
-        """
+        put_response = self.tester.put(self.url + str(utils.SERVER_GROUP) +
+                                       '/' + str(server_id) + '/' + str(db_id)
+                                       + '/' + str(self.schema_id) + '/' +
+                                       str(trigger_func_id),
+                                       data=json.dumps(data),
+                                       follow_redirects=True)
+        self.assertEquals(put_response.status_code, 200)
+        # Disconnect the database
+        database_utils.disconnect_database(self, server_id, db_id)
 
-        trigger_funcs_utils.delete_trigger_function(cls.tester)
-        schema_utils.delete_schema(cls.tester)
-        database_utils.delete_database(cls.tester)
-        server_utils.delete_server(cls.tester)
-        utils.delete_parent_id_file()
+    def tearDown(self):
+        pass
